package bitel.billing.test.convert;

import java.math.BigDecimal;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import bitel.billing.common.CommonTimeUtils;
import bitel.billing.common.CommonUtils;
import bitel.billing.common.KernelConst;
import bitel.billing.server.ServerEventProcessor;
import bitel.billing.server.admin.bean.AddressUtils;
import bitel.billing.server.contract.bean.Contract;
import bitel.billing.server.contract.bean.ContractManager;
import bitel.billing.server.contract.bean.ContractService;
import bitel.billing.server.contract.bean.ContractServiceManager;
import bitel.billing.server.contract.bean.ContractStatus;
import bitel.billing.server.contract.bean.ContractStatusManager;
import bitel.billing.server.contract.bean.ContractTariff;
import bitel.billing.server.contract.bean.ContractTariffManager;
import bitel.billing.server.npay.bean.ServiceObject;
import bitel.billing.server.npay.bean.ServiceObjectManager;
import bitel.billing.server.util.DefaultServerSetup;
import bitel.billing.server.util.PswdGen;
import bitel.billing.server.util.SetupData;
import bitel.billing.server.util.TimeUtils;
import bitel.billing.server.util.Utils;

/*
 *  -    .mysql  
 */
public class Skat
{
	private static int PID_FIO = 1;
	private static int PID_PHONE = 1;
	private static int PID_COMMENT = 1; 	
	private static int PID_ADDRESS = 2;
	
	private static int COMMON_PATTERN = 2;
	private static int PAY_SERVICE = 1;
	
	private static int GROUP = 1;
	private static int NPAY_MODULE = 1;
	
	private static SetupData bgSetup;
	
	private static Map<String, Integer > streetMap = new  HashMap<String, Integer > ();
	private static Map<Integer, Map<String, Integer> >  houseMap = new HashMap<Integer, Map<String, Integer> >(); 
	private static Map<String, Integer >  cityMap = new HashMap<String, Integer>();
	private static Map<String, Integer > billingTarifMap = new HashMap<String, Integer>();	
	private static Map<String, Integer > groupTarifMap = new HashMap<String, Integer>();
	private static int groupIndex = 0; 
	
	private static Calendar contractDate = TimeUtils.parseCalendar ( "01.12.2008", "dd.MM.yyyy" );
	
	
	public static List< Map > getUsers ( DefaultServerSetup setup  )
	{
		
		List< Map > result = new ArrayList<Map> ();
		Connection con = null;	 
			 
		try
		{
			String query = " SELECT * from dogovors as contract " +
							" LEFT JOIN clients as client ON contract.client_id = client.id " +
							" LEFT JOIN type_dogovor  as tariff ON contract.type_id = tariff.id " +
							" LEFT JOIN houses  as house ON client.house_id = house.id " +
							" LEFT JOIN streets  as street ON house.street_id = street.id " +
							" LEFT JOIN city  ON street.id_city = city.id";
			//LIMIT 0, 100
							 
			con = setup.getDBConnectionFromPool();		
			
			PreparedStatement ps = con.prepareStatement( query );
			
			ResultSet rs = ps.executeQuery();
			
			
			while (rs.next())
			{
				Map<String, Object> line = new HashMap<String, Object>();
				
				line.put( "client_id", rs.getInt( "client_id" ) );
				line.put( "status_id", rs.getInt( "status_id" ) );
				line.put( "type_id", rs.getInt( "type_id" ) );
				line.put( "balance", rs.getDouble( "balance" ) );
				line.put( "contract_count", rs.getString( "contract.name" ) );
				line.put( "name", rs.getString( "client.name" ) );
				line.put( "surname", rs.getString( "surname" ) );
				line.put( "otchestvo", rs.getString( "otchestvo" ) );
				line.put( "house_id", rs.getInt( "house_id" ) );
				line.put( "index_client", rs.getBigDecimal( "index_client" ) );
				line.put( "phone", rs.getString( "phone" ) );
				line.put( "tv_count", rs.getInt( "tv_count" ) );
				line.put( "comment_client", rs.getString( "comment_client" ) );
				line.put( "flat", rs.getInt( "kvart" ) );
				line.put( "tariff", rs.getString( "tariff.name" ) );
				line.put( "street_id", rs.getString( "street_id" ) );
				line.put( "house_number", rs.getString( "number" ) );
				line.put( "floor", rs.getInt( "floor" ) );
				line.put( "podezd", rs.getInt( "podezd" ) );
				line.put( "street", rs.getString( "street" ) );
				line.put( "city", rs.getString( "city" ) );
				
			
				result.add( line );
				
			}
		} catch (SQLException e)
		{ 
			e.printStackTrace();
		}
		finally
		{
			setup.returnConToPool( con );
		}
		
		return result; 
	}
	
	private static boolean readBoolean(Map line, String name)
	{
		Boolean result = (Boolean) line.get( name );
		return result == null ? false :  result;
	}
	
	private static Date readDate(Map line, String name)
	{
		Date result = (Date) line.get( name );
		return result;
	}
	
	private static String readString(Map line, String name)
	{
		String result = (String) line.get( name );
		return result;
	}
	
	private static int readInt(Map line, String name, int defaultValue)
	{
		int result = line.get( name ) != null ? ( Integer ) line.get( name ) : defaultValue;  
		return result;
	}	
	
	private static double readDouble(Map line, String name)
	{
		double result = (Double) line.get( name );
		return result;
	}	
	
	private static BigDecimal readDecimal(Map line, String name)
	{
		BigDecimal result = (BigDecimal) line.get( name );
		return result;
	}	
			
		
	private static List<Contract> createContracts(	List <Map> users)
	{
		
		List<Contract> result = new ArrayList<Contract>();
		Connection con = null;
		Date currDate = new Date();
		try
		{
			con = bgSetup.getDBConnectionFromPool();
			
			
			
			System.out.println( users.size() + " contacts was found..");
			System.out.println( " importing contracts..");
			
			for ( Map line : users )
        	{
        		int patternId = COMMON_PATTERN;
        		
        		ContractManager manager =  new ContractManager( con );
        		
        		
        		String title =  readString( line,  "contract_count" );
        		if ( Utils.isEmptyString( title ) )
        		{
        			title = null;			
        		}
        		
        		String passwd = PswdGen.generatePassword( bgSetup.getPasswordLengthAuto(), bgSetup.getPasswordChars() );
        		
        		Contract contract = manager.createFromPattern( patternId, title, contractDate, passwd );
        		
        		if (contract != null)
        		{	
        			int cid = contract.getID();
        			
        			result.add( contract );
        			updateContactInfo( contract.getID(), line);        			
        			updateContractParams(cid, line);
        			
        			updateAddress( cid, line, streetMap, houseMap, cityMap );        			
        			updateContactBalance(contract, con, cid, line, currDate);        			
        			updateTarif( cid,  line );
        			updateStatus( cid, line );
        			updateNpayService( cid, line );
        			updateGroup( cid, line );
        		}
        		
        		
        		        		
        	}			
			
			System.out.println( result.size() + " contacts was added..");
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
		finally
		{
			bgSetup.returnConToPool( con );
		}
	
		
		return result;
	}



	private static void updateContactBalance(	Contract contract,
	                                         	Connection con,
												int cid,												
												Map line,
												Date currDate)
	{
		
		Calendar cal = new GregorianCalendar();
		cal.setTime( currDate );
		
		int year = cal.get( Calendar.YEAR );
		int month = cal.get( Calendar.MONTH  ) + 1;
		try
		{			
			String query = "INSERT INTO contract_balance(yy, mm, cid, summa1, summa2, summa3, summa4) VALUES(?, ?, ?, ?, 0, 0, 0)";
			PreparedStatement ps =  con.prepareStatement( query );
			int idx = 1;
			ps.setInt( idx++, year );
			ps.setInt( idx++, month );
			ps.setInt( idx++, cid );
			ps.setDouble( idx++, readDouble( line, "balance" ) );
			
			ps.executeUpdate();
			
			
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
		finally
		{			
		}		
		
	}


	private static void updateAddress(	int cid,	                                  	
	                                 	Map map,
	                                 	Map<String, Integer > streetMap,	                                 	
	                                 	Map<Integer, Map<String, Integer> >  houseMap,
	                                 	Map<String, Integer > cityMap)
	{
		
		
		Connection con = null;
		try
		{

			con = bgSetup.getDBConnectionFromPool();
			
			
			//-, 267-51
		
			BigDecimal indexDec = readDecimal( map,  "index_client" );
			String index = "";
			if ( indexDec != null)
			{
				index = indexDec.toBigInteger().toString();
			}
			
			String city = readString( map, "city" );
			String street = readString( map, "street" );
			String house = readString( map, "house_number" );;
			String frac = "";
			String flat = String.valueOf(  readInt( map, "flat", -1 ) );
			
			if ( CommonUtils.isEmptyString( city ) ||
					CommonUtils.isEmptyString( street ) ||
					CommonUtils.isEmptyString( house ) )
			{
				return;
			}
			
			
			
			if ( flat == "-1")
			{
				flat = "";
			}
			Matcher m = null;
			
			String template = "^(\\d+)(\\D+)?$";										
			Pattern pattern = Pattern.compile( template );			
			
			// 
			
			
			if( house != null && (m = pattern.matcher( house )).find() )
			{				
				house = m.group( 1 );
				frac = m.group( 2 );				
			}			
			if ( frac == null)
			{
				frac = "";
			}
			Integer cityId = -1;
			if ( city != null)
			{
				cityId = cityMap.get( city );
				if ( cityId == null)
				{			
					String query = "INSERT into address_city(title) VALUES(?) ";
					PreparedStatement ps =  con.prepareStatement(   query );
					ps.setString( 1, city );								
					ps.executeUpdate();
					cityId = ConvertUtil.lastInsertId( con );
					cityMap.put( city, cityId );
				}				
			}					

			Integer streetId = -1;			
			
		
			if ( flat == null )
			{
				flat = "";
			}
			
			
			streetId = streetMap.get( street );
			
			if ( streetId == null)
			{			
				String query = "INSERT into address_street( title, cityId) VALUES(?, ?) ";
				PreparedStatement ps =  con.prepareStatement(   query );
				ps.setString( 1, street );								
				ps.setInt( 2, cityId );
				ps.executeUpdate();
				streetId = ConvertUtil.lastInsertId( con );
				streetMap.put( street, streetId );
			}
			
			Map<String, Integer> houses = houseMap.get( streetId ); 
			if ( houses == null )
			{
				houses = new HashMap<String, Integer>();
				
				houseMap.put( streetId, houses );
			}
			String key = ConvertUtil.getHouseKey( Integer.valueOf( house), frac );
			if ( houses.get( key ) == null )
			{
				
				String query = "INSERT INTO address_house " + "( cityid,  areaid, quarterid, streetid,"
				   + " house, frac, box_index, amount, comment, dt) " + "VALUES ( ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";
				PreparedStatement ps =  con.prepareStatement(   query );
				ps.setInt( 1, cityId );
				ps.setInt( 2, 0 );
				ps.setInt( 3, 0 );
				ps.setInt( 4, streetId );
				ps.setInt( 5, Integer.valueOf( house) );
				ps.setString( 6, frac );
				ps.setString( 7, "" );
				ps.setInt( 8, 0 );
				ps.setString( 9, "" );
				ps.setDate( 10, TimeUtils.convertDateToSQL( new  Date() ) );
				ps.executeUpdate();		
				int houseId = ConvertUtil.lastInsertId( con );
				houses.put( key, houseId );
			}
			
			int houseId =  houses.get( key );
			
			
			
			
			String addressFull = AddressUtils.getAddress( bgSetup, index, city, "", "", street, house, frac, "", "", "", "", ""  ); 
			
			String query = "INSERT INTO contract_parameter_type_2 " +
			"( cid, pid, hid, flat,  pod, floor, address, comment, room) " +
			"VALUES ( ?, ?, ?, ?, ?, ?, ?, ?, ? )";
			PreparedStatement ps =  con.prepareStatement(   query );
			ps.setInt( 1, cid );
			ps.setInt( 2, PID_ADDRESS );
			ps.setInt( 3, houseId );
			ps.setString( 4, flat );
			ps.setInt( 5, -1 );
			ps.setInt( 6, -1 );
			ps.setString( 7, addressFull );
			ps.setString( 8, "" );
			ps.setString( 9, "" );
			ps.executeUpdate();		   
			
			
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
		finally
		{			
			bgSetup.returnConToPool( con );
		}				
		
	}	


	private static void updateContractParams(	int cid, Map<String, String> map)
	{
		Connection con = null;
		try
		{
			con = bgSetup.getDBConnectionFromPool();	
			String fio = getFIO( map );

			ConvertUtil.addContactParamString( cid, con, fio, PID_FIO );		
			ConvertUtil.addContactParamString( cid, con, map.get( "phone" ), PID_PHONE );
			ConvertUtil.addContactParamString( cid, con, map.get( "comment" ), PID_COMMENT );
	

		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
		finally
		{			
			bgSetup.returnConToPool( con );
		}	
		
	}

	private static String getFIO( Map<String, String> map )
	{
		String fio  =  map.get( "surname" ) + " "  +
					map.get( "name" )  +  " " +					 
					map.get( "otchestvo")
		;
		return fio;
	}	
	


	private static void updateContactInfo(	int cid,
											Map line)
	{
		
		Connection con = null;
		
		try
		{
			con = bgSetup.getDBConnectionFromPool();
			String query = "UPDATE contract SET gr=gr| ?,   " +					
					" comment = ?" +					
					" WHERE id=?";
			PreparedStatement ps = con.prepareStatement( query );
			int idx =1;
			ps.setInt( idx++, GROUP );										
			ps.setString( idx++,  getFIO(  line )  );			
			ps.setInt( idx++, cid );

			ps.executeUpdate();
			
		}
		catch(Exception ex)
		{
			ex.printStackTrace();
		}
		finally
		{
			bgSetup.returnConToPool( con );
		}
			
	}
	
	private static void updateTarif(	int cid,
	                                 	Map<String, String> map)
	{
		
		
		Connection con = null;
		try
		{

			con = bgSetup.getDBConnectionFromPool();
		    
		    String tarifName = map.get( "tariff" );
		    if ( CommonUtils.isEmptyString( tarifName ) )
		    {
		    	return;
		    }
		    		
		    tarifName = tarifName.trim(); 
		    tarifName = tarifName.toLowerCase();
		    
		    if ( CommonUtils.isEmptyString( tarifName ) )
		    {
		    	//System.out.println("error: tarif is empty for user " + number);
		    	return;
		    }
		    		    
		    
		    Integer tpid = billingTarifMap.get( tarifName );
		    
	    	if ( tpid == null)
	    	{	
	    		tpid = ConvertUtil.addNewTariff( con,  tarifName);
	    		System.out.println("New Tariff was added:" + tarifName);
	    		billingTarifMap.put( tarifName, tpid );
	    		//  
	    		String query = "UPDATE contract_group SET title=?, enable=? WHERE id=?";
	    		PreparedStatement ps = con.prepareStatement( query );
	    		ps.setString( 1, tarifName );
	    		ps.setInt( 2, 1 );
	    		ps.setInt( 3, groupIndex );
	    		ps.executeUpdate();
	    		groupTarifMap.put( tarifName, groupIndex ); 
	    		
	    	}
	        
	    	ContractTariff value = new ContractTariff();
	    	value.setTariffPlanID( tpid );
	    	value.setContractID( cid );
	    	value.setDate1( contractDate );
    		
    		new ContractTariffManager( con ).updateContractTariff( value );
			
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
		finally
		{			
			bgSetup.returnConToPool( con );
		}				
	}		

	private static void updateGroup(	int cid,
	    	                            Map<String, String> map )
	{
		
		
		Connection con = null;
		try
		{

			con = bgSetup.getDBConnectionFromPool();
		    
		    String tarifName = map.get( "tariff" );
		    if ( CommonUtils.isEmptyString( tarifName ) )
		    {
		    	return;
		    }
		
    		// 
    		Integer grid = groupTarifMap.get( tarifName );
    		if ( grid == null)
    		{
    			//  
	    		String query = "UPDATE contract_group SET title=?, enable=? WHERE id=?";
	    		PreparedStatement ps = con.prepareStatement( query );
	    		ps.setString( 1, tarifName );
	    		ps.setInt( 2, 1 );
	    		ps.setInt( 3, groupIndex );
	    		ps.executeUpdate();
	    		groupTarifMap.put( tarifName, groupIndex );
	    		grid = groupIndex;
	    		
	    		groupIndex++;
    		}
			
    		String query = "UPDATE contract SET gr=gr| ? " +															
					" WHERE id=?";
			PreparedStatement ps = con.prepareStatement( query );
			int idx =1;
			ps.setInt( idx++, 1 << grid);																
			ps.setInt( idx++, cid );

			ps.executeUpdate();
    		
    		
			
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
		finally
		{			
			bgSetup.returnConToPool( con );
		}				
	}		

	    		
	
	private static void updateStatus( int cid, Map map )
	{
		Connection con = null;
		
		try
		{
			con = bgSetup.getDBConnectionFromPool();
			
			int oldStatus = readInt( map, "status", -1 );
			int statusId = KernelConst.CONTRACT_STATUS_ACTIVE; 
			if ( oldStatus == 1 )
			{
				statusId = KernelConst.CONTRACT_STATUS_ACTIVE;
			}
			//,  
			else if ( oldStatus == 0 || oldStatus == 3 )
			{
				statusId = KernelConst.CONTRACT_STATUS_DISCONNECTED;
			}
			// ,  . 
			else if ( oldStatus == 2 || oldStatus == 4 || oldStatus == 5) 
			{
				statusId = KernelConst.CONTRACT_STATUS_SUSPENDED;
			}

			ContractStatus status = new ContractStatus();
	        status.setContractId( cid );
	        status.setUserId( 0 );
	        status.setStatus( statusId );
	        status.setDate1( contractDate  );
	        status.setDate2( null );
	        status.setComment( "  " );

	        ContractStatusManager statusManager = new ContractStatusManager( con );
	        statusManager.changeStatus( status.clone() );	
	
			
		}
		catch(Exception ex)
		{
			ex.printStackTrace();
		}
		finally
		{
			bgSetup.returnConToPool( con );
		}		
		
	}		
	
	private static void updateNpayService( int cid, Map map )
	{
		Connection con = null;
		
		try
		{
			con = bgSetup.getDBConnectionFromPool();
			
			int count =  readInt(  map, "tv_count", -1);
			//   
			if (count <= 0 )
			{
				return;
			}
			
			// 
			ContractService cs = new ContractService();
			
			ContractServiceManager serviceManager = new ContractServiceManager( con );
			List<Integer> sids = new ArrayList<Integer>();
			sids.add( PAY_SERVICE );
			List<ContractService> list =  serviceManager.getContractServiceList( cid, sids, contractDate, null );
			//  ,    
			if ( list.size() == 0)						
			{
				cs = new ContractService();
				cs.setContractID( cid );
				cs.setServiceID( PAY_SERVICE );
				cs.setDateFrom( contractDate.getTime() ) ;
				cs.setComment( " " );
				serviceManager.updateContractService( "new", cs );
			}
			else
			{
				cs = list.get( 0 );
			}
			
			//,      1..         
			// ,    1      
			if (count <= 1 )
			{
				return;
			}
			
			ServiceObject serviceObject = new ServiceObject();
	        serviceObject.setContractServiceId( cs.getID() );
	        serviceObject.setObjectId( 0 );
	        serviceObject.setCol( count );
	        
	        ServiceObjectManager man = new ServiceObjectManager( con, NPAY_MODULE );
	        man.updateServiceObject( serviceObject );
								
			
		}
		catch(Exception ex)
		{
			ex.printStackTrace();
		}
		finally
		{
			bgSetup.returnConToPool( con );
		}		
	}	

	public static void main( String[] args )
	{
		long start =  System.currentTimeMillis();
		try
		{
			
			bgSetup = new SetupData( "data.data" );


			FileSetup settings = new FileSetup("convert_skat");
			
			GROUP = settings.getIntValue( "group", -1 );			
		
			PID_FIO = settings.getIntValue( "pid.fio", -1 );;
			PID_ADDRESS = settings.getIntValue( "pid.address", -1 );
			PID_COMMENT = settings.getIntValue( "pid.comment", -1 );
			PID_PHONE = settings.getIntValue( "pid.phone", -1 );
			
			COMMON_PATTERN = settings.getIntValue( "template.common", -1 );
			PAY_SERVICE = settings.getIntValue( "npay.service", -1 );
			NPAY_MODULE = settings.getIntValue( "npay.module", -1 );
			
			
			//ConvertEventProcessor -  ,     
			//ContractRemover     ..
			//       - ServerEventProcessor ,
			//   ServerEventProcessor..
			// false             -     			
			
			ConvertEventProcessor.initProcessor( bgSetup, false, new ServerEventProcessor() );
			ConvertUtil.removeContracts( GROUP, bgSetup);
			int i = 1;
			String key = null;
			
			cityMap = ConvertUtil.getBillingCityMap ( bgSetup );
			streetMap = ConvertUtil.getBillingStreetMap ( bgSetup );
			houseMap = ConvertUtil.geHouseMap( bgSetup ); 		
			billingTarifMap = ConvertUtil.getBillingTariffMap( bgSetup );
			
			if( settings.getHashValuesWithPrefix( key =  "import."+ (i++) + "." ).size() > 0  )
            {                 
                DefaultServerSetup setup = new DefaultServerSetup();
                
                
                for( Entry<String,String> param : settings.getHashValuesWithPrefix( key ).entrySet() )
                {
                	setup.setValue( param.getKey(), param.getValue() );
                }
                setup.initConnectionPool();
                convert( bgSetup, setup );
            }    
			
			
			System.out.println( "ok" );
			
			
		}
		catch( Exception ex)
		{
			ex.printStackTrace();
		}
		
		long diff =  System.currentTimeMillis() - start ;
		System.out.println( "time = " + CommonTimeUtils.formatDeltaTime( diff / 1000l ) );
	}

	private static void convert( SetupData bgSetup2, DefaultServerSetup setup )
	{
        List < Map > users = getUsers( setup );                
        
        createContracts(  users);		
		
	}	

}
