package bitel.billing.test.convert;

import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.sql.Connection;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import bitel.billing.common.TimeUtils;
import bitel.billing.server.contract.bean.ContractService;
import bitel.billing.server.contract.bean.ContractServiceManager;
import bitel.billing.server.contract.bean.ContractTariff;
import bitel.billing.server.contract.bean.ContractTariffManager;
import bitel.billing.server.phone.bean.ClientItem;
import bitel.billing.server.phone.bean.ClientItemManager;
import bitel.billing.server.util.SetupData;

import com.Ostermiller.util.ExcelCSVParser;

public class TkUralPhoneLoad
{
    private static final String FILE = "/home/shamil/work/tkural/UTG2.csv";    
    private static final int PHONE_MID = 1;
    private static final int CONTRACT_ID = 1106423;
    private static final int TARIFF_POVREM_JUR = 7;
    private static final int ABON_LINE = 4;
    
    private SetupData setup = new SetupData( "bitel.billing.test.convert.tkural" );
    private Connection con;
        
    public TkUralPhoneLoad()
    {
        try 
        {
            con = setup.getDBConnectionFromPool();
            
            ClientItemManager itemManager = new ClientItemManager( con, PHONE_MID );
            ContractServiceManager csm = new ContractServiceManager( con );
            ContractTariffManager ctm = new ContractTariffManager( con );
            
            int rowNum = 0;
                        
            String[][] data = ExcelCSVParser.parse( new InputStreamReader( new FileInputStream( FILE ), "Cp1251" ) , ';' );
            if( data != null && data.length > 0 )
            {
                final int rowCount = data.length;
                for( rowNum = 1; rowNum < rowCount; rowNum++ )
                {
                    String[] fields = data[rowNum];
                    Date date = TimeUtils.parseDate( fields[2], "dd.MM.yyyy" );
                    String number = "7343" + fields[3];
                    
                    List<String> numberList = new ArrayList<String>(1);
                    numberList.add( number );
                    
                    ClientItem item = new ClientItem();
                    item.setSourceId( 1 );
                    item.setType( ClientItem.TYPE_POINT );
                    item.setContractId( CONTRACT_ID );
                    item.setDate1( TimeUtils.convertDateToCalendar( date ) );
                    item.setClientNumbers( numberList );
                    
                    System.out.println( number );
                    
                    try 
                    {
                        itemManager.addClientItem( item );
                    } 
                    catch (Exception e) 
                    {
                        System.out.println( " " + number + " " + e.getMessage() );
                        continue;
                    }
                    
                    ContractService service = new ContractService();
                    service.setContractID( CONTRACT_ID );
                    service.setEntityMid( PHONE_MID );
                    service.setEntityId( item.getId() );
                    service.setDateFrom( date );
                    service.setServiceID( ABON_LINE );
                    
                    csm.updateContractService( "new", service );
                    
                    ContractTariff tariff = new ContractTariff();
                    tariff.setContractID( CONTRACT_ID );
                    tariff.setEntityMid( PHONE_MID );
                    tariff.setEntityId( item.getId() );
                    tariff.setDate1( TimeUtils.convertDateToCalendar( date ) );
                    tariff.setTariffPlanID( TARIFF_POVREM_JUR );
                    
                    ctm.updateContractTariff( tariff );
                }
            }
        }        
        catch (Exception e) 
        {
            e.printStackTrace();
        }
    }    
    
    public static void main( String[] args )
    {
        new TkUralPhoneLoad();
    }
}